#!/bin/sh
#
# udev.create_static_devices.sh
#
# Create missing static devices
#

mknod=/bin/mknod
devlist=$1

if [ ! -r "$devlist" ]; then
    echo "Cannot read device list from $1"
    exit 1
fi

while read name type major minor mode; do
    case "$name" in
	\#*)
	continue
	;;
	*/*)
	dir=${name%/*}
	mkdir -p "/dev/$dir"
	;;
    esac
    if [ -e "/dev/$name" ]; then
	continue
    fi
    if [ -n "$mode" ]; then
	args="-m $mode"
    else
	args=
    fi
    if [ "$type" = "l" ] ; then
	ln -f -s $major "/dev/$name"
    else
	$mknod $args "/dev/$name" $type $major $minor
    fi
done < $devlist
