#!/bin/sh
#
# load-ide-modules.sh
#
# Load IDE modules corresponding to the setting in /proc/ide/.../media
#

PATH=/bin:/sbin:/usr/bin

if [ -z "$DEVPATH" ]; then
    DEVPATH=$1
fi

if [ -z "$DEVPATH" ]; then
	exit 1
fi

path=${DEVPATH#*/ide?/}
hostnum=${path%.?}

drive=${path#?.}

drive=$(printf "%x" $(($drive + $hostnum * 2 + 10)) )

proc="/proc/ide/ide$hostnum/hd$drive/media"

if [ -r "$proc" ]; then
	read media < $proc
	if [ "$media" = "cdrom" ]; then
		module="ide-cd"
	else
		module="ide-$media"
	fi
	/sbin/modprobe $module
else
    exit 1
fi

